<%-- src_input_date_combo_javascript tag --%>
<%@ tag pageEncoding="UTF-8" body-content="empty"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://www.jasminesoft.co.jp/jfc" prefix="jfc" %>
<%@ taglib tagdir="/WEB-INF/tags" prefix="tags" %>
<fmt:setBundle basename="jfcapp"/>

<%@ attribute name="value" required="true" type="java.lang.Object" %> <%-- ${TemplateModel_p.FDateCombo} --%>
<%@ attribute name="name" required="true" %> <%-- TemplateModel_p_002ff_date_combo --%>
<%@ attribute name="year_textfield" type="java.lang.Boolean" %>
<%@ attribute name="year_begin" %> <%-- 1990 --%>
<%@ attribute name="year_range" %> <%-- 10 --%>
<%@ attribute name="type" required="true" %> <%-- YMDHMS or YMDHM or YMDH or YMD or YM or Y --%>
<%@ attribute name="subformat" %> <%-- common.js formatDateObject function --%>
<%@ attribute name="rangetype" %> <%-- normal or begin or end or onerange --%>
<%@ attribute name="onerangeEndName" %>
<%@ attribute name="onerangeEndValue" type="java.lang.Object" %>
<%@ attribute name="nendoBeginMonth" type="java.lang.Integer" %> <%-- 1...12 --%>
<%@ attribute name="selectinput_config" %>
<%@ attribute name="valuetype" %> <%-- date or dateTime, default is date --%>
<%@ attribute name="dateformat" %>

<%-- nendoBeginMonth --%>
<c:if test="${nendoBeginMonth <= 0}">
  <c:remove var="nendoBeginMonth"/>
</c:if>
<c:if test="${nendoBeginMonth != null}">
  <c:choose>
  <c:when test="${nendoBeginMonth > 1}">
    <c:set var="nendoEndMonth">${nendoBeginMonth-1}</c:set>
  </c:when>
  <c:otherwise>
    <c:set var="nendoEndMonth">12</c:set>
  </c:otherwise>
  </c:choose>
</c:if>

<input data-dojo-type="dijit/form/TextBox" type="hidden" id="${name}" name="${name}" value="${fn:escapeXml(value.content)}" data-dojo-props="onChange: function() { updateContent(null, this); }" />
<c:if test="${rangetype=='onerange'}">
<input data-dojo-type="dijit/form/TextBox" type="hidden" id="${onerangeEndName}" name="${onerangeEndName}" value="${fn:escapeXml(onerangeEndValue.content)}" data-dojo-props="onChange: function() { updateContent(null, this); }" />
</c:if>

<script language="JavaScript">
<!--
require(["dojo/ready"], function(ready) {
  ready(function() {
    setDate_${name}(document.getElementById('${name}').form);
  });
});

function createValue_${name}(year,month,day_of_month,hour,minute,second) {
  if (!year) {
	return "";
  }
<c:choose>
<c:when test="${valuetype == 'dateTime'}">
    return year+'-'+get2ketastr(month)+'-'+get2ketastr(day_of_month)+' '+hour+':'+minute+':'+second;
</c:when>
<c:otherwise>
    return year+'-'+get2ketastr(month)+'-'+get2ketastr(day_of_month);
</c:otherwise>
</c:choose>
}

<c:choose>
<c:when test="${rangetype == 'begin' or rangetype == 'end'}">
<c:if test="${rangetype == 'begin'}">
<c:choose>
<c:when test="${nendoBeginMonth != null}">
  <c:set var="defaultMonth">${nendoBeginMonth}</c:set>
</c:when>
<c:otherwise>
  <c:set var="defaultMonth">1</c:set>
</c:otherwise>
</c:choose>
<c:set var="defaultDate">1</c:set>
<c:set var="defaultHour">0</c:set>
<c:set var="defaultMinute">0</c:set>
<c:set var="defaultSecond">0</c:set>
</c:if>
<c:if test="${rangetype == 'end'}">
<c:choose>
<c:when test="${nendoBeginMonth != null}">
  <c:set var="defaultMonth">${nendoEndMonth}</c:set>
</c:when>
<c:otherwise>
  <c:set var="defaultMonth">12</c:set>
</c:otherwise>
</c:choose>
<c:set var="defaultDate">getLastDayOfThisMonth(year,month-1)</c:set>
<c:set var="defaultHour">23</c:set>
<c:set var="defaultMinute">59</c:set>
<c:set var="defaultSecond">59</c:set>
</c:if>
function setDate_${name}(f) {
    if (f.${name}.value == '') {
        return;
    }
    var datearray;
    try {
        <c:choose>
        <c:when test="${fn:length(dateformat) > 0}">
            datearray = createDateArray(f.${name}.value, false, '${dateformat}');
        </c:when>
        <c:otherwise>
          datearray = createDateArray(f.${name}.value, false);
        </c:otherwise>
        </c:choose>
    } catch (e) {
        console.error(e);
        setInput_${name}(f, f.${name}.value);
        return;
    }
    if (datearray[0] == -1) {
        return;
    }
    var year = datearray[0];
<c:if test="${type == 'Y'}">
    var month = ${defaultMonth}
</c:if>
<c:if test="${type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var month;
    if (datearray[1] != -1) {
        month = datearray[1];
    } else {
        month = ${defaultMonth};
    }
</c:if>
    var inputyear = year;
<c:if test="${nendoBeginMonth != null}">
    if (month < ${nendoBeginMonth} && month >= 1) {
        inputyear--;
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM'}">
    var day_of_month = ${defaultDate}
</c:if>
<c:if test="${type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var day_of_month;
    if (datearray[2] != -1) {
        day_of_month = datearray[2];
    } else {
        day_of_month = ${defaultDate};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD'}">
    var hour = ${defaultHour}
</c:if>
<c:if test="${type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var hour;
    if (datearray[3] != -1) {
        hour = datearray[3];
    } else {
        hour = ${defaultHour};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD' || type == 'YMDH'}">
    var minute = ${defaultMinute}
</c:if>
<c:if test="${type == 'YMDHM' || type == 'YMDHMS'}">
    var minute;
    if (datearray[4] != -1) {
        minute = datearray[4];
    } else {
        minute = ${defaultMinute};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM'}">
    var second = ${defaultSecond}
</c:if>
<c:if test="${type == 'YMDHMS'}">
    var second;
    if (datearray[5] != -1) {
        second = datearray[5];
    } else {
        second = ${defaultSecond};
    }
</c:if>
    require(["dijit/registry", "dojo/dom"], function(registry, dom) {
      var widget = registry.byId("${name}");
      if (widget) {
        widget.set("value", createValue_${name}(year, month, day_of_month, hour, minute, second));
      } else {
        dom.byId("${name}").value = createValue_${name}(year, month, day_of_month, hour, minute, second);
      }
    });
    setYearInput_${name}(f, inputyear, month, day_of_month, hour, minute, second);
}

function expandDate_${name}(f) {
    var datearray = getDateArray_${name}(f);
    if (datearray == null) {
        setYearInput_${name}(f, "", "", "", "", "", "");
        return;
    }
    if (datearray[0] == -1) {
        f.${name}.value = ''
        return;
    }
    var year = datearray[0];
<c:if test="${type == 'Y'}">
    var month = ${defaultMonth}
</c:if>
<c:if test="${type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var month;
    if (datearray[1] != -1) {
        month = datearray[1];
    } else {
        month = ${defaultMonth};
    }
</c:if>
    var inputyear = year;
<c:if test="${nendoBeginMonth != null}">
    if (month < ${nendoBeginMonth} && month >= 1) {
        year++;
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM'}">
    var day_of_month = ${defaultDate}
</c:if>
<c:if test="${type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var day_of_month;
    if (datearray[2] != -1) {
        day_of_month = datearray[2];
        var lastday = getLastDayOfThisMonth(year,month-1);
        if (lastday < day_of_month) {
            day_of_month = lastday;
        }
    } else {
        day_of_month = ${defaultDate};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD'}">
    var hour = ${defaultHour}
</c:if>
<c:if test="${type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var hour;
    if (datearray[3] != -1) {
        hour = datearray[3];
    } else {
        hour = ${defaultHour};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD' || type == 'YMDH'}">
    var minute = ${defaultMinute}
</c:if>
<c:if test="${type == 'YMDHM' || type == 'YMDHMS'}">
    var minute;
    if (datearray[4] != -1) {
        minute = datearray[4];
    } else {
        minute = ${defaultMinute};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM'}">
    var second = ${defaultSecond}
</c:if>
<c:if test="${type == 'YMDHMS'}">
    var second;
    if (datearray[5] != -1) {
        second = datearray[5];
    } else {
        second = ${defaultSecond};
    }
</c:if>
    require(["dijit/registry", "dojo/dom"], function(registry, dom) {
      var widget = registry.byId("${name}");
      if (widget) {
        widget.set("value", createValue_${name}(year, month, day_of_month, hour, minute, second));
      } else {
        dom.byId("${name}").value = createValue_${name}(year, month, day_of_month, hour, minute, second);
      }
    });
    setYearInput_${name}(f, inputyear, month, day_of_month, hour, minute, second);
}
</c:when>
<c:when test="${rangetype == 'onerange'}">
<c:choose>
<c:when test="${nendoBeginMonth != null}">
  <c:set var="defaultBeginMonth">${nendoBeginMonth}</c:set>
  <c:set var="defaultEndMonth">${nendoEndMonth}</c:set>
</c:when>
<c:otherwise>
  <c:set var="defaultBeginMonth">1</c:set>
  <c:set var="defaultEndMonth">12</c:set>
</c:otherwise>
</c:choose>

<c:set var="defaultBeginDate">1</c:set>
<c:set var="defaultEndDate">getLastDayOfThisMonth(year_end,month_end-1)</c:set>
<c:set var="defaultBeginHour">0</c:set>
<c:set var="defaultBeginMinute">0</c:set>
<c:set var="defaultBeginSecond">0</c:set>
<c:set var="defaultEndHour">23</c:set>
<c:set var="defaultEndMinute">59</c:set>
<c:set var="defaultEndSecond">59</c:set>

function setDate_${name}(f) {
    if (f.${name}.value == '') {
        return;
    }
    var datearray_begin;
    var datearray_end;
    try {
        datearray_begin = createDateArray(f.${name}.value, true);
        datearray_end = createDateArray(f.${onerangeEndName}.value, true);
    } catch (e) {
        setInput_${name}(f, f.${name}.value);
        return;
    }
    var widget;
    var hiddenInput;
    require(["dijit/registry", "dojo/dom"], function(registry, dom) {
      widget = registry.byId("${name}");
      if (datearray_begin[0] == -1 || datearray_end[0] == -1) {
        if (widget) {
          widget.set("value", "");
        } else {
          hiddenInput = dom.byId("${name}");
          hiddenInput.value = "";
        }
        f.${onerangeEndName}.value = '';
      }
    });
    if (datearray_begin[0] == -1 || datearray_end[0] == -1) {
      return;
    }
    var year = datearray_begin[0];
    var inputyear = year;
    var day_of_month;
<c:if test="${type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var month;
    if (datearray_begin[1] != -1 && datearray_begin[1] == datearray_end[1]) {
        month = datearray_begin[1];
    } else {
	    if (datearray_begin[1] === -1) {
	      month = ${defaultBeginMonth};
        } else {
          month = datearray_begin[1];
        }
        var value = createValue_${name}(datearray_begin[0], month, ${defaultBeginDate}, ${defaultBeginHour}, ${defaultBeginMinute}, ${defaultBeginSecond});
        if (widget) {
          widget.set("value", value);
        } else {
          hiddenInput.value = value;
        }
        var year_end = datearray_end[0] || datearray_begin[0]; <%-- defaultEndDateで使う --%>
        var month_end = datearray_end[1] || datearray_begin[1]; <%-- defaultEndDateで使う --%>
        day_of_month = datearray_begin[2] || ${defaultBeginDate};
        f.${onerangeEndName}.value = createValue_${name}(year_end, month_end, ${defaultEndDate}, ${defaultEndHour}, ${defaultEndMinute}, ${defaultEndSecond});
        setYearInput_${name}(f, year, month, day_of_month, null, null, null);
        return;
    }
<c:if test="${nendoBeginMonth != null}">
    if (month < ${nendoBeginMonth} && month >= 1) {
        inputyear--;
    }
</c:if>
</c:if>
<c:if test="${type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    if (datearray_begin[2] != -1 && datearray_begin[2] == datearray_end[2]) {
        day_of_month = datearray_begin[2];
    } else {
        if (datearray_begin[2] === -1) {
          day_of_month = ${defaultBeginDate};
        } else {
          day_of_month = datearray_begin[2];
        }
        var value = createValue_${name}(datearray_begin[0], datearray_begin[1], day_of_month, ${defaultBeginHour}, ${defaultBeginMinute}, ${defaultBeginSecond});
        if (widget) {
          widget.set("value", value);
        } else {
          hiddenInput.value = value;
        }
        var year_end = datearray_end[0] || datearray_begin[0]; <%-- defaultEndDateで使う --%>
        var month_end = datearray_end[1] || datearray_begin[1]; <%-- defaultEndDateで使う --%>
        f.${onerangeEndName}.value = createValue_${name}(year_end, month_end, ${defaultEndMonth}, ${defaultEndHour}, ${defaultEndMinute}, ${defaultEndSecond});
        setYearInput_${name}(f, inputyear, month, day_of_month, null, null, null);
        return;
    }
</c:if>
<c:if test="${type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var hour;
    if (datearray_begin[3] != -1 && datearray_begin[3] == datearray_end[3]) {
        hour = datearray_begin[3];
    } else {
        var value = createValue_${name}(datearray_begin[0], datearray_begin[1], datearray_begin[2], ${defaultBeginHour}, ${defaultBeginMinute}, ${defaultBeginSecond});
        if (widget) {
          widget.set("value", value);
        } else {
          hiddenInput.value = value;
        }
        f.${onerangeEndName}.value = createValue_${name}(datearray_end[0], datearray_end[1], datearray_begin[2], ${defaultEndHour}, ${defaultEndMinute}, ${defaultEndSecond});
        setYearInput_${name}(f, inputyear, month, day_of_month, null, null, null);
        return;
    }
</c:if>
<c:if test="${type == 'YMDHM' || type == 'YMDHMS'}">
    var minute;
    if (datearray_begin[4] != -1 && datearray_begin[4] == datearray_end[4]) {
        minute = datearray_begin[4];
    } else {
        var value = createValue_${name}(datearray_begin[0], datearray_begin[1], datearray_begin[2], datearray_begin[3], ${defaultBeginMinute}, ${defaultBeginSecond});
        if (widget) {
          widget.set("value", value);
        } else {
          hiddenInput.value = value;
        }
        f.${onerangeEndName}.value = createValue_${name}(datearray_end[0], datearray_end[1], datearray_begin[2], datearray_begin[3], ${defaultEndMinute}, ${defaultEndSecond});
        setYearInput_${name}(f, inputyear, month, day_of_month, hour, null, null);
        return;
    }
</c:if>
<c:if test="${type == 'YMDHMS'}">
    var second;
    if (datearray_begin[5] != -1 && datearray_begin[5] == datearray_end[5]) {
        second = datearray_begin[5];
    } else {
        var value = createValue_${name}(datearray_begin[0], datearray_begin[1], datearray_begin[2], datearray_begin[3], datearray_begin[4], ${defaultBeginSecond});
        if (widget) {
          widget.set("value", value);
        } else {
          hiddenInput.value = value;
        }
        f.${onerangeEndName}.value = createValue_${name}(datearray_end[0], datearray_end[1], datearray_begin[2], datearray_begin[3], datearray_begin[4], ${defaultEndSecond});
        setYearInput_${name}(f, inputyear, month, day_of_month, hour, minute, null);
        return;
    }
</c:if>
<c:if test="${type == 'Y'}">
    var value = createValue_${name}(datearray_begin[0], ${defaultBeginMonth}, ${defaultBeginDate}, ${defaultBeginHour}, ${defaultBeginMinute}, ${defaultBeginSecond});
    if (widget) {
      widget.set("value", value);
    } else {
      hiddenInput.value = value;
    }
    var year_end = datearray_end[0] || datearray_begin[0]; <%-- defaultEndDateで使う --%>
    var month_end = ${defaultEndMonth}; <%-- defaultEndDateで使う --%>
    f.${onerangeEndName}.value = createValue_${name}(year_end, ${defaultEndMonth}, ${defaultEndDate}, ${defaultEndHour}, ${defaultEndMinute}, ${defaultEndSecond});
    setYearInput_${name}(f, inputyear, null, null, null, null, null);
</c:if>
<c:if test="${type == 'YM'}">
    var value = createValue_${name}(datearray_begin[0], datearray_begin[1], ${defaultBeginDate}, ${defaultBeginHour}, ${defaultBeginMinute}, ${defaultBeginSecond});
    if (widget) {
      widget.set("value", value);
    } else {
      hiddenInput.value = value;
    }
    var year_end = datearray_end[0] || datearray_begin[0]; <%-- defaultEndDateで使う --%>
    var month_end = datearray_end[1] || datearray_begin[1]; <%-- defaultEndDateで使う --%>
    f.${onerangeEndName}.value = createValue_${name}(year_end, month_end, ${defaultEndDate}, ${defaultEndHour}, ${defaultEndMinute}, ${defaultEndSecond});
    setYearInput_${name}(f, inputyear, month, null, null, null, null);
</c:if>
<c:if test="${type == 'YMD'}">
    var value = createValue_${name}(datearray_begin[0], datearray_begin[1], datearray_begin[2], ${defaultBeginHour}, ${defaultBeginMinute}, ${defaultBeginSecond});
    if (widget) {
      widget.set("value", value);
    } else {
      hiddenInput.value = value;
    }
    f.${onerangeEndName}.value = createValue_${name}(datearray_end[0], datearray_end[1], datearray_end[2], ${defaultEndHour}, ${defaultEndMinute}, ${defaultEndSecond});
    setYearInput_${name}(f, inputyear, month, day_of_month, null, null, null);
</c:if>
<c:if test="${type == 'YMDH'}">
    var value = createValue_${name}(datearray_begin[0], datearray_begin[1], datearray_begin[2], datearray_begin[3], ${defaultBeginMinute}, ${defaultBeginSecond});
    if (widget) {
      widget.set("value", value);
    } else {
      hiddenInput.value = value;
    }
    f.${onerangeEndName}.value = createValue_${name}(datearray_end[0], datearray_end[1], datearray_end[2], datearray_begin[3], ${defaultEndMinute}, ${defaultEndSecond});
    setYearInput_${name}(f, inputyear, month, day_of_month, hour, null, null);
</c:if>
<c:if test="${type == 'YMDHM'}">
    var value = createValue_${name}(datearray_begin[0], datearray_begin[1], datearray_begin[2], datearray_begin[3], datearray_begin[4], ${defaultBeginSecond});
    if (widget) {
      widget.set("value", value);
    } else {
      hiddenInput.value = value;
    }
    f.${onerangeEndName}.value = createValue_${name}(datearray_end[0], datearray_end[1], datearray_end[2], datearray_begin[3], datearray_begin[4], ${defaultEndSecond});
    setYearInput_${name}(f, inputyear, month, day_of_month, hour, minute, null);
</c:if>
<c:if test="${type == 'YMDHMS'}">
    var value = createValue_${name}(datearray_begin[0], datearray_begin[1], datearray_begin[2], datearray_begin[3], datearray_begin[4], datearray_begin[5]);
    if (widget) {
      widget.set("value", value);
    } else {
      hiddenInput.value = value;
    }
    f.${onerangeEndName}.value = createValue_${name}(datearray_end[0], datearray_end[1], datearray_end[2], datearray_begin[3], datearray_begin[4], datearray_begin[5]);
    setYearInput_${name}(f, inputyear, month, day_of_month, hour, minute, second);
</c:if>
}

function expandDate_${name}(f) {
    var datearray = getDateArray_${name}(f);
    if (datearray == null) {
        f.${onerangeEndName}.value = '';
        return;
    }
    if (datearray[0] == -1) {
        f.${name}.value = '';
        f.${onerangeEndName}.value = '';
        return;
    }
    var year_begin = datearray[0];
    var year_end = datearray[0];
<c:if test="${type == 'Y'}">
    var month_begin = ${defaultBeginMonth};
    var month_end = ${defaultEndMonth};
</c:if>
<c:if test="${type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var month_begin;
    var month_end;
    if (datearray[1] != -1) {
        month_begin = datearray[1];
        month_end = datearray[1];
    } else {
        month_begin = ${defaultBeginMonth};
        month_end = ${defaultEndMonth};
    }
</c:if>
<c:if test="${nendoBeginMonth != null}">
    if (month_begin < ${nendoBeginMonth} && month_begin >= 1) {
        year_begin++;
    }
</c:if>
<c:if test="${nendoBeginMonth != null}">
    if (month_end < ${nendoBeginMonth} && month_end >= 1) {
        year_end++;
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM'}">
    var day_of_month_begin = ${defaultBeginDate};
    var day_of_month_end = ${defaultEndDate};
</c:if>
<c:if test="${type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var day_of_month_begin;
    var day_of_month_end;
    if (datearray[2] != -1) {
        day_of_month_begin = datearray[2];
        day_of_month_end = datearray[2];
    } else {
        day_of_month_begin = ${defaultBeginDate};
        day_of_month_end = ${defaultEndDate};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD'}">
    var hour_begin = ${defaultBeginHour};
    var hour_end = ${defaultEndHour};
</c:if>
<c:if test="${type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var hour_begin;
    var hour_end;
    if (datearray[3] != -1) {
        hour_begin = datearray[3];
        hour_end = datearray[3];
    } else {
        hour_begin = ${defaultBeginHour};
        hour_end = ${defaultEndHour};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD' || type == 'YMDH'}">
    var minute_begin = ${defaultBeginMinute};
    var minute_end = ${defaultEndMinute};
</c:if>
<c:if test="${type == 'YMDHM' || type == 'YMDHMS'}">
    var minute_begin;
    var minute_end;
    if (datearray[4] != -1) {
        minute_begin = datearray[4];
        minute_end = datearray[4];
    } else {
        minute_begin = ${defaultBeginMinute};
        minute_end = ${defaultEndMinute};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM'}">
    var second_begin = ${defaultBeginSecond};
    var second_end = ${defaultEndSecond};
</c:if>
<c:if test="${type == 'YMDHMS'}">
    var second_begin;
    var second_end;
    if (datearray[5] != -1) {
        second_begin = datearray[5];
        second_end = datearray[5];
    } else {
        second_begin = ${defaultBeginSecond};
        second_end = ${defaultEndSecond};
    }
</c:if>
    require(["dijit/registry", "dojo/dom"], function(registry, dom) {
      var widget = registry.byId("${name}");
      if (widget) {
        widget.set("value", createValue_${name}(year_begin, month_begin, day_of_month_begin, hour_begin, minute_begin, second_begin));
      } else {
        dom.byId("${name}").value = createValue_${name}(year_begin, month_begin, day_of_month_begin, hour_begin, minute_begin, second_begin);
      }
    });
    setYearInput_${name}(f, year_begin, month_begin, day_of_month_begin, hour_begin, minute_begin, second_begin);
    f.${onerangeEndName}.value = createValue_${name}(year_end, month_end, day_of_month_end, hour_end, minute_end, second_end);
}
</c:when>
<c:otherwise>
<c:set var="defaultMonth">1</c:set>
<c:set var="defaultDate">1</c:set>
<c:set var="defaultHour">0</c:set>
<c:set var="defaultMinute">0</c:set>
<c:set var="defaultSecond">0</c:set>

function setDate_${name}(f) {
    if (f.${name}.value == '') {
        return;
    }
    var datearray;
    try {
        datearray = createDateArray(f.${name}.value, false);
    } catch (e) {
        setInput_${name}(f, f.${name}.value);
        return;
    }
    if (datearray[0] == -1) {
        return;
    }
    var year = datearray[0];
<c:if test="${type == 'Y'}">
    var month = ${defaultMonth}
</c:if>
<c:if test="${type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var month;
    if (datearray[1] != -1) {
        month = datearray[1];
    } else {
        month = ${defaultMonth}
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM'}">
    var day_of_month = ${defaultDate}
</c:if>
<c:if test="${type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var day_of_month;
    if (datearray[2] != -1) {
        day_of_month = datearray[2];
    } else {
        day_of_month = ${defaultDate}
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD'}">
    var hour = ${defaultHour}
</c:if>
<c:if test="${type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var hour;
    if (datearray[3] != -1) {
        hour = datearray[3];
    } else {
        hour = ${defaultHour};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD' || type == 'YMDH'}">
    var minute = ${defaultMinute}
</c:if>
<c:if test="${type == 'YMDHM' || type == 'YMDHMS'}">
    var minute;
    if (datearray[4] != -1) {
        minute = datearray[4];
    } else {
        minute = ${defaultMinute};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM'}">
    var second = ${defaultSecond}
</c:if>
<c:if test="${type == 'YMDHMS'}">
    var second;
    if (datearray[5] != -1) {
        second = datearray[5];
    } else {
        second = ${defaultSecond};
    }
</c:if>
    require(["dijit/registry", "dojo/dom"], function(registry, dom) {
      var widget = registry.byId("${name}");
      if (widget) {
        widget.set("value", createValue_${name}(year,month,day_of_month,hour,minute,second));
      } else {
        dom.byId("${name}").value = createValue_${name}(year,month,day_of_month,hour,minute,second);
      }
    });
    setYearInput_${name}(f, year, month, day_of_month, hour, minute, second);
}

function expandDate_${name}(f) {
  var datearray = getDateArray_${name}(f);
  if (datearray == null) {
      setYearInput_${name}(f, "", "", "", "", "", "");
      return;
  }
    if (datearray[0] == -1) {
        f.${name}.value = '';
        return;
    }
    var year = datearray[0];
<c:if test="${type == 'Y'}">
    var month = ${defaultMonth}
</c:if>
<c:if test="${type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var month;
    if (datearray[1] != -1) {
        month = datearray[1];
    } else {
        month = ${defaultMonth}
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM'}">
    var day_of_month = ${defaultDate}
</c:if>
<c:if test="${type == 'YMD' || type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var day_of_month;
    if (datearray[2] != -1) {
        day_of_month = datearray[2];
        var lastday = getLastDayOfThisMonth(year,month-1);
        if (lastday < day_of_month) {
            day_of_month = lastday;
        }
    } else {
        day_of_month = ${defaultDate}
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD'}">
    var hour = ${defaultHour}
</c:if>
<c:if test="${type == 'YMDH' || type == 'YMDHM' || type == 'YMDHMS'}">
    var hour;
    if (datearray[3] != -1) {
        hour = datearray[3];
    } else {
        hour = ${defaultHour};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD' || type == 'YMDH'}">
    var minute = ${defaultMinute}
</c:if>
<c:if test="${type == 'YMDHM' || type == 'YMDHMS'}">
    var minute;
    if (datearray[4] != -1) {
        minute = datearray[4];
    } else {
        minute = ${defaultMinute};
    }
</c:if>
<c:if test="${type == 'Y' || type == 'YM' || type == 'YMD' || type == 'YMDH' || type == 'YMDHM'}">
    var second = ${defaultSecond}
</c:if>
<c:if test="${type == 'YMDHMS'}">
    var second;
    if (datearray[5] != -1) {
        second = datearray[5];
    } else {
        second = ${defaultSecond};
    }
</c:if>
    require(["dijit/registry", "dojo/dom"], function(registry, dom) {
      var widget = registry.byId("${name}");
      if (widget) {
        widget.set("value", createValue_${name}(year,month,day_of_month,hour,minute,second));
      } else {
        dom.byId("${name}").value = createValue_${name}(year,month,day_of_month,hour,minute,second);
      }
    });
    setYearInput_${name}(f, year, month, day_of_month, hour, minute, second);
}
</c:otherwise>
</c:choose>
-->
</script>
